/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/

namespace IRDB_SDK
{
	using namespace std;

	class DataScoop_t : virtual public BaseObj_t
	{

		protected:
			DataScoop_t() {}
			DataScoop_t(const DataScoop_t& copy) = delete;
		public:
			virtual ~DataScoop_t() { }

			virtual const string     getName()       const = 0;
			virtual const string&    getContents()   const = 0;
			virtual AddressID_t*     getStart()      const = 0;
			virtual AddressID_t*     getEnd()        const = 0;
			virtual Type_t*          getType()       const = 0;
			virtual VirtualOffset_t  getSize()       const = 0;
			virtual bool             isReadable()    const = 0;
			virtual bool             isWriteable()   const = 0;
			virtual bool             isExecuteable() const = 0;
			virtual bool             isRelRo()       const = 0;
			virtual uint8_t          getRawPerms()   const = 0;

			virtual void setName(const string &n)     = 0;
			virtual void setContents(const string &n) = 0;
			virtual void setStart( AddressID_t* addr) = 0;
			virtual void setEnd( AddressID_t* addr )  = 0;
			virtual void setType( Type_t*  t)         = 0;
			virtual void setReadable()                = 0;
			virtual void setWriteable()               = 0;
			virtual void setExecuteable()             = 0;
			virtual void setRelRo()                   = 0;
			virtual void clearReadable()              = 0;
			virtual void clearWriteable()             = 0;
			virtual void clearExecuteable()           = 0;
			virtual void clearRelRo()                 = 0;
			virtual void setRawPerms(int newperms)    = 0;

	};
}
